#include <iostream>
#include <vector>
#include "fenvikovo_stablo.h"

using namespace std;

void dodaj(int x, vector<int>& stablo) {
	uvecaj(x, 1, stablo);
}

void ukloni(int x, vector<int>& stablo) {
	uvecaj(x, -1, stablo);
}

int rang(int x, vector<int>& stablo) {
	if(x == 0)
		return 0;
	return upit(0, x - 1, stablo);
}

int kti(int k, vector<int>& stablo) {
	int l = 0, r = stablo.size() - 2;
	int res = -1;
	while(l <= r) {
		int s = (l + r) / 2;
		if(upit(0, s, stablo) >= k) {
			r = s - 1;
			res = s;
		}
		else
			l = s + 1;
	}
	return res;
}

int main() {
	int m, q;
	cin >> m >> q;
	vector<int> stablo(m + 1);
	while(q--) {
		string s;
		cin >> s;

		int x;
		cin >> x;

		if(s == "dodaj")
			dodaj(x, stablo);
		else if(s == "ukloni")
			ukloni(x, stablo);
		else if(s == "rang")
			cout << rang(x, stablo) << '\n';
		else if(s == "kti")
			cout << kti(x, stablo) << '\n';
	}
	return 0;
}
