#include "fenvikovo_stablo.h"

vector<int> napravi_stablo(vector<int>& niz) {
	vector<int> stablo(niz.size() + 1);
	copy(niz.begin(), niz.end(), stablo.begin() + 1);

	for(int i = 1; i < stablo.size(); i++)
		if(i + (i & -i) < stablo.size())
			stablo[i + (i & -i)] += stablo[i];

	return stablo;
}

void uvecaj(int i, int x, vector<int>& stablo) {
	for(i++; i < stablo.size(); i += i & -i)
		stablo[i] += x;
}

void postavi(int i, int x, vector<int>& stablo) {
	uvecaj(i, x - upit(i, i, stablo), stablo);
}

int upit(int i, vector<int>& stablo) {
	int suma = 0;
	for(i++; i > 0; i -= i & -i)
		suma += stablo[i];
	return suma;
}

int upit(int l, int r, vector<int>& stablo) {
	return upit(r, stablo) - upit(l - 1, stablo);
}
